function titles(books) {
    return books.map(book => { return book.title });
}

function titlesBetween(books, startYear, endYear) {
    let between = [];
    for (let book of books) {
        if (book.publicationYear > startYear && book.publicationYear < endYear) {
            between.push(book.title);
        }
    }
    return between;
}

function bookCountBetween(books, startYear, endYear) {
    let count = 0;
    for (let book of books) {
        if (book.publicationYear >= startYear && book.publicationYear <= endYear) {
            count++
        }
    }
    return count;
}

function yearsActive(books) {
    let oldest = Infinity;
    let newest = -Infinity;
    for (let book of books) {
        if (book.publicationYear < oldest) {
            oldest = book.publicationYear;
        }
        if (book.publicationYear > newest) {
            newest = book.publicationYear;
        }
    }
    return newest - oldest + 1;
}

function bookCountByAuthor(books) {
    let authors = {};
    for (let book of books) {
        if (book.author in authors) {
            authors[book.author] += 1;
        } else {
            authors[book.author] = 1;
        }
    }
    return authors;
}

function capitalizeTitle(title) {
    let strArray = title.split(' ');
    let resultArray = [];
    for (let string of strArray) {
        let string2 = string.slice(0, 1).toUpperCase() + string.slice(1).toLowerCase();
        resultArray.push(string2);
    }
    return resultArray.join(' ');
}

function distribute(xs, n) {
    let children = new Array(n);
    for (let i = 0; i < children.length; i++) {
        children[i] = [];
    }
    let child = 0;
    for (let i = 0; i < xs.length; i++) {
        children[child].push(xs[i]);
        child++;
        if (child >= n) {
            child = 0;
        }
    }
    return children;
}

function center(pageWidth, lines) {
    let grid = [];
    for (let line of lines) {
        let row = [];
        let strArray = line.split('');
        strArray.forEach(char => row.push(char));
        let delta = pageWidth - strArray.length
        let pos = true;
        while (delta !== 0) {
            if (pos) {
                row.push(' ');
                pos = false;
            } else {
                row.unshift(' ');
                pos = true;
            }
            delta--;
        }
        grid.push(row);
    }
    return grid;
}

function mask(string) {
    if (string.length === 0) {
        return "";
    } else if (string.charAt(0) === " ") {
        return " " + mask(string.slice(1));
    } else {
        return "*" + mask(string.slice(1));
    }
}